// Listing 9-1 - Testing Serial MP3 player

#define HEADER_START   0x7E
#define HEADER_VERSION 0xFF
#define TAIL_END       0xEF
#define CMD_PLAY_NEXT  0x01
#define CMD_PLAY_PREV  0x02
#define CMD_PLAY_IDX   0x03

int8_t commands[8] = {0, 0, 0, 0, 0, 0, 0, 0}; 
// Holds command set to send to MP3

#include <SoftwareSerial.h>
SoftwareSerial MP3(2, 3); // Module TX to D2; module RX to D3

void controlMP3(int8_t command, int16_t data)
{
    commands[0] = HEADER_START;             // Header byte 0 (start)
    commands[1] = HEADER_VERSION;             // Header byte 1 (version)
    commands[2] = 0x06;             // Header byte 2 (length cmd + data)
    commands[3] = command;          // Command byte 
    commands[4] = 0x00;             // Feedback (0x00 = no, 0x01 = yes)
    commands[5] = (int8_t)(data >> 8); // Data byte 0
    commands[6] = (int8_t)(data);      // Data byte 1
    commands[7] = 0xEF;             // End byte
    for (int i = 0; i < 8; i++)
    {
        MP3.write(commands[i]);
    }
}

void setup() 
{
    MP3.begin(9600);
    controlMP3(0x09, 0x02); // Select flash card for operation.
    delay(500);
    controlMP3(0x0D, 0);    // Resume playback, no feedback.
    delay(500);
}

void loop()
{
  controlMP3(0x01, 0); // Next track, zero data
  delay(10000);
}
