// Listing 12-1: Test Writing to USB flash drive

char text1[] = "This is a line of text in the form of a character array, followed by a new line function. \n";
char text2[] = "This is another line of text. I hope you're enjoying the book. John. \n";
char floatChar[8] = "";
float f = 12.34567;

#include <Ch376msc.h>
#include <SoftwareSerial.h>

SoftwareSerial Serial1(7, 6);
Ch376msc USBdrive(Serial1);

void fileWrite()
{
  Serial.println("fileWrite()");   
  USBdrive.setFileName("TEST1.TXT");  // set the file name
  USBdrive.openFile();                // open the file

  // write some integers
  for (int a = 0; a < 20; a++) 
  {
    USBdrive.writeNum(a);
    USBdrive.writeChar(',');
  }  

  // write new line
  USBdrive.writeChar('\n');  

  // write lines of text
  USBdrive.writeFile(text1, strlen(text1)); 
  USBdrive.writeFile(text2, strlen(text2));   

  USBdrive.writeChar('\n');  

  // write floating-point number - first convert to char
  dtostrf(f,2,5,floatChar); // 2 whole digits, 5 decimals
  USBdrive.writeFile(floatChar, strlen(floatChar));

  USBdrive.closeFile();               // close the file
  Serial.println("Finished!");
}

void setup() 
{
  Serial.begin(115200);   // for serial monitor
  Serial1.begin(9600);    // for USB module
  USBdrive.init();
  delay(5000);
}

void loop() 
{
  if (USBdrive.checkIntMessage())
  {
    if (USBdrive.getDeviceStatus()) 
    {
      Serial.println("Flash drive attached!");
    } else {
      Serial.println("Flash drive detached!");
    }
  }
  fileWrite();
  delay(5000);
}