// Listing 12-2: Test Appending to USB flash drive

#include <Ch376msc.h>
#include <SoftwareSerial.h>

SoftwareSerial USBserial(7, 6);
Ch376msc USBdrive(USBserial);

void fileAppend()
{
  Serial.println("fileAppend()");
  USBdrive.setFileName("TEST1.TXT");  // set the file name
  if (USBdrive.openFile() == ANSW_USB_INT_SUCCESS) 
  {            
    USBdrive.moveCursor(CURSOREND);
  }
  if (USBdrive.getFreeSectors()) 
  {
    USBdrive.writeNumln(random(1000));
  } else  {
    Serial.println("Disk full");
  }
  USBdrive.closeFile();
  Serial.println("Finished");
  delay(1000);
}

void setup() 
{
  Serial.begin(115200);   // for serial monitor
  USBserial.begin(9600);    // for USB module
  USBdrive.init();
  delay(5000);
  randomSeed(analogRead(0));
}

void loop() 
{
  if (USBdrive.checkIntMessage())
  {
    if (USBdrive.getDeviceStatus()) {
      Serial.println(F("Flash drive attached!"));
    } else {
      Serial.println(F("Flash drive detached!"));
    }
  }

  fileAppend();
  do {} while (1);
}