// Listing 12-3: Writing and reading integers with USB flash drive
#include <Ch376msc.h>
#include <SoftwareSerial.h>

SoftwareSerial Serial1(7,6);
Ch376msc USBdrive(Serial1);

void writeIntegers()
{
  int number;
   if(USBdrive.driveReady())
   {
    USBdrive.setFileName("NUMBERS.TXT");
    USBdrive.openFile();
    Serial.println(F("Writing integers:"));
    for(int a=0; a<10; a++)
    {
      number = random(-1000, 1000);
      Serial.print(number); Serial.print(" ");
      USBdrive.writeNumln(number);
    }
    USBdrive.closeFile();
    Serial.println(F("Finished writing integers."));
    Serial.println();
  }
}

void readIntegers()
{
  USBdrive.setFileName("NUMBERS.TXT");
    USBdrive.openFile();
    Serial.println(F("Reading integer numbers..."));

    while(!USBdrive.getEOF())
    {
      Serial.print(USBdrive.readLong());
      Serial.print(" ");
    }
    USBdrive.closeFile();
    Serial.println(F("Finished reading integers."));
    Serial.println();
}

void setup()
{
  randomSeed(analogRead(0));
  Serial.begin(115200);
  Serial1.begin(9600);
  USBdrive.init();
  delay(5000);
}

void loop() 
{
  if (USBdrive.checkIntMessage())
  {
    if (USBdrive.getDeviceStatus()) {
      Serial.println(F("Flash drive attached!"));
    } else {
      Serial.println(F("Flash drive detached!"));
      return;
    }
  }
  writeIntegers();
  delay(2000);
  readIntegers();
  delay(30000);
}
