// Listing 13-3: Testing PCF8574 LCD and PS/2 Keyboard

#include <LiquidCrystal_PCF8574.h>
#include <Wire.h>
LiquidCrystal_PCF8574 lcd(0x27);

#include <PS2Keyboard.h>
PS2Keyboard keyboard;

int xPosition = 0;
int yPosition = 0;

void setup() {
  Wire.begin();
  Wire.beginTransmission(0x27);
  lcd.begin(16, 2);
  lcd.setBacklight(255);
  lcd.blink();  // turns off lcd.noBlink();
  keyboard.begin(4, 3);
}

void loop() {
  if (keyboard.available()) 
  {

    // read the next key
    char c = keyboard.read();

    // check for some of the special keys
    switch (c)
    {
      case   

   if (c == PS2_ENTER) {
      xPosition = 0;
      if (yPosition == 0) {
        yPosition = 1;
      } else if (yPosition == 1) {
        yPosition = 0;
      }
      lcd.setCursor(xPosition, yPosition);
    } else if (c == PS2_TAB) {
      lcd.print("[Tab]");
    } else if (c == PS2_ESC) {
      lcd.home();
      lcd.clear();
      xPosition = 0;
      yPosition = 0;
    } else if (c == PS2_PAGEDOWN) {
      lcd.print("[PgDn]");
    } else if (c == PS2_PAGEUP) {
      lcd.print("[PgUp]");
    } else if (c == PS2_LEFTARROW) {
      lcd.print("[Left]");
    } else if (c == PS2_RIGHTARROW) {
      lcd.print("[Right]");
    } else if (c == PS2_UPARROW) {
      lcd.print("[Up]");
    } else if (c == PS2_DOWNARROW) {
      lcd.print("[Down]");
    } else if (c == PS2_DELETE) {
      lcd.print("[Del]");
    } else {
      // otherwise, just print all normal characters
      lcd.print(c);
      xPosition++;
      if (xPosition > 15) {
        xPosition = 0;
        if (yPosition == 0) {
          yPosition = 1;
        } else if (yPosition == 1) {
          yPosition = 0;
        }
        lcd.setCursor(xPosition, yPosition);
      }
    }
  }
}
