// Listing 15-2 - Testing DS3231 Library

#include <DS3231.h>
#include <Wire.h>

DS3231 RTCmodule;

bool century = false;
bool h12Flag = false;
bool pmFlag = false;

int hh, mm, ss, dd, dow, mo, yy;

void setTime()
{
  RTCmodule.setClockMode(false);  // Set to 24h time.
  RTCmodule.setYear(22);
  RTCmodule.setMonth(1);
  RTCmodule.setDate(28);
  RTCmodule.setDoW(6); // Sunday = 1
  RTCmodule.setHour(14);
  RTCmodule.setMinute(05);
  RTCmodule.setSecond(30);
}

void showTime()
{
  // Get data from RTC.
  dd = RTCmodule.getDate();
  dow = RTCmodule.getDoW();
  mo = RTCmodule.getMonth(century);
  yy = RTCmodule.getYear();
  hh = RTCmodule.getHour(h12Flag, pmFlag);
  mm = RTCmodule.getMinute();
  ss = RTCmodule.getSecond();

  // Send information to Serial Monitor
  switch(dow)
  {
    case 1: Serial.print("Sunday "); break;
    case 2: Serial.print("Monday "); break;
    case 3: Serial.print("Tuesday "); break;
    case 4: Serial.print("Wednesday "); break;
    case 5: Serial.print("Thursday "); break;
    case 6: Serial.print("Friday "); break;
    case 7: Serial.print("Saturday "); break;                
  }
  Serial.print(dd, DEC);
  Serial.print("/");
  Serial.print(mo, DEC);
  Serial.print("/");
  Serial.print(yy, DEC);
  Serial.print(" | ");
  Serial.print(hh, DEC);
  Serial.print(":");
  if (mm < 10) // Check for leading zero on minutes.
  {
    Serial.print("0");
  }
  Serial.print(mm, DEC);
  Serial.print(":");
  if (ss < 10) // Check for leading zero on seconds.
  {
    Serial.print("0");
  }
  Serial.println(ss, DEC);
}

void setup()
{
  Serial.begin(9600);
  Wire.begin();
  // setTime(); 
}

void loop()
{
  showTime();
  delay(1000);
}
