// Listing 15-3 - Wake up on Interrupt

#include <LowPower.h>

void interruptFunction(){}

void setup()
{
  pinMode(2, INPUT);
  pinMode(13, OUTPUT); // for demo LED
}

void loop()
{
  // start using interrupt pin
  attachInterrupt(0, interruptFunction, FALLING);

  // Enter power down state with ADC and BOD module disabled.
  // Wake up when D2 is low.
  LowPower.powerDown(SLEEP_FOREVER, ADC_OFF, BOD_OFF);

  // Disable external pin interrupt on wake up pin.
  // Not using interrupt any more
  detachInterrupt(0);

  // Do something here when interrupt triggered
  digitalWrite(13, HIGH);
  delay(1000);
  digitalWrite(13, LOW);
}
