// Listing 6-1 - Testing DS3231 RTC Library

#include <Wire.h>
#include <DS3231.h>
DS3231 RTC;

bool century = false;
bool h12Flag = false;
bool pmFlag = false;
byte year = 22;
byte month = 9;
byte date = 2;
byte hour = 11;
byte minute = 8;
byte second = 0;

void setTimeData()
{
  RTC.setYear(year);
  RTC.setMonth(month);
  RTC.setDate(date);
  RTC.setHour(hour);
  RTC.setMinute(minute);
  RTC.setSecond(second);
  RTC.setClockMode(false); // Set clock to 24 hour
}

void setup()
{
  Wire.begin();
  //setTimeData();   // Set time and date
  Serial.begin(9600);
}

void loop()
{
  // Display data on serial monitor
  Serial.print(RTC.getDate());
  Serial.print("/");
  Serial.print(RTC.getMonth(century));
  Serial.print("/20");
  Serial.print(RTC.getYear());
  Serial.print(" - ");
  Serial.print(RTC.getHour(h12Flag, pmFlag));
  Serial.print(":");
  if (RTC.getMinute() < 10) {
    Serial.print("0");
  }
  Serial.print(RTC.getMinute());
  Serial.print(":");
  if (RTC.getSecond() < 10) {
    Serial.print("0");
  }
  Serial.println(RTC.getSecond());
  delay(1000);
}
