// Project #8 - Creating a Single-Digit Electronic Die

int digits[] = {B11111100, // 0
                B01100000, // 1
                B11011010, // 2
                B11110010, // 3
                B01100110, // 4
                B10110110, // 5
                B10111110, // 6
                B11100000, // 7
                B11111110, // 8
                B11110110}; // 9

void display(int n, boolean point)
{
  if (point == false)
  {
    PORTD = digits[n];
  } else if (point == true)
  {
    PORTD = digits[n] | B00000001;
  }
}

void displayRandom(int _delay)
{
  display(random(1, 7), false);  // display the number
  if (_delay > 0)
  {
    delay(_delay);              // hold the display on for the delay received
  }
  else if (_delay == 0)
  {
    do                   // the delay entered was zero, hold the display on forever
    {}
    while (1);
  }
}

void setup()
{
  DDRD = B11111111; // set PORTD (digital 7~0) to outputs
  randomSeed(analogRead(0));      // seed the random number generator
}

void loop()
{
  int a;
  // cycle the LEDs around for effect
  for ( a = 0; a < 100; a++)
  {
    displayRandom(50);
  }
  // display numbers with increasing delay
  for (a = 1; a < 10; a++)
  {
    displayRandom(a * 100);
  }
  // and stop at the final random number and LED
  displayRandom(0);
}
