// Project 21 - Building an Arduino Event Logger

#include <Wire.h>
#include <DS3231.h>
DS3231 RTC;

#include <SD.h>
#define offPin 9

bool century = false;
bool h12Flag = false;
bool pmFlag = false;
byte year = 22;
byte month = 9;
byte date = 2;
byte hour = 11;
byte minute = 8;
byte second = 0;

void setTimeData()
{
  RTC.setYear(year);
  RTC.setMonth(month);
  RTC.setDate(date);
  RTC.setHour(hour);
  RTC.setMinute(minute);
  RTC.setSecond(second);
  RTC.setClockMode(false); // Set clock to 24 hour
}

void turnOff()
{
  digitalWrite(offPin, LOW);
}

void logEvent()
{
  // Create the file for writing
  File dataFile = SD.open("DATA.TXT", FILE_WRITE);
  // if the file is ready, write to it:
  if (dataFile)
  {
    dataFile.print("Event occurred on: ");
    dataFile.print(RTC.getDate());
    dataFile.print("/");
    dataFile.print(RTC.getMonth(century));
    dataFile.print("/20");
    dataFile.print(RTC.getYear());
    dataFile.print(" - ");
    dataFile.print(RTC.getHour(h12Flag, pmFlag));
    dataFile.print(":");
    if (RTC.getMinute() < 10) {
      dataFile.print("0");
    }
    dataFile.print(RTC.getMinute());
    dataFile.print(":");
    if (RTC.getSecond() < 10) {
      dataFile.print("0");
    }
    dataFile.println(RTC.getSecond());
    dataFile.close(); // close the file once the system has finished with it
  }
}

void setup()
{
  Wire.begin();
  //setTimeData();   // Set time and date
  pinMode(offPin, OUTPUT);
  digitalWrite(offPin, HIGH);
  pinMode(10, OUTPUT);
  // Check that the memory card exists and is usable
  if (!SD.begin(10))
  {
    // Stop sketch
    return;
  }
}

void loop()
{
  logEvent();  // log event to SD card
  delay(1000); // wait a moment
  turnOff();
}
