// Project #23 – Controlling the Mains Outlet with a Timer

#include <Wire.h>
#include <DS3231.h>
DS3231 RTC;

bool century = false;
bool h12Flag = false;
bool pmFlag = false;
byte year = 22;
byte month = 9;
byte date = 19;
byte hour = 21;
byte minute = 53;
byte second = 0;

void setTimeData()
{
  RTC.setYear(year);
  RTC.setMonth(month);
  RTC.setDate(date);
  RTC.setHour(hour);
  RTC.setMinute(minute);
  RTC.setSecond(second);
  RTC.setClockMode(false); // Set clock to 24 hour
}

void mainsOff()
{
  digitalWrite(3, HIGH);
  delay(1000);  
  digitalWrite(3, LOW);
  digitalWrite(13, LOW);
}

void mainsOn()
{
  digitalWrite(2, HIGH);
  delay(1000);  
  digitalWrite(2, LOW);
  digitalWrite(13, HIGH);
}

void setup()
{
  mainsOff();
  //setTimeData();   // Set time and date
  Wire.begin();
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(13, OUTPUT);
  digitalWrite(13, LOW);
}

void turnOn(int onHour, int onMinute)
{
  if ((RTC.getHour(h12Flag, pmFlag) == hour) && (onMinute == RTC.getMinute()))
  {
    mainsOn();
    delay(59100);
  }
}

void turnOff(int offHour, int offMinute)
{
  if ((RTC.getHour(h12Flag, pmFlag) == hour) && (offMinute == RTC.getMinute()))
  {
    mainsOff();
    delay(59100);
  }
}

void loop()
{
  turnOn(17, 02);
  turnOff(17, 03);
  turnOn(17, 04);
  turnOff(17, 05);
  turnOn(17, 06);
  turnOff(17, 07);
}
