// Project 24 - Controlling the Mains Outlet with SMS
#include <SoftwareSerial.h>
SoftwareSerial cell(2, 3);
char inchar;

void mainsOff()
{
  digitalWrite(5, HIGH);
  delay(1000);
  digitalWrite(5, LOW);
  digitalWrite(13, LOW);
}

void mainsOn()
{
  digitalWrite(4, HIGH);
  delay(1000);
  digitalWrite(4, LOW);
  digitalWrite(13, HIGH);
}

void setup()
{
  pinMode(5, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(13, OUTPUT);
  pinMode(8, OUTPUT);  
  mainsOff();
  digitalWrite(8, HIGH);
  delay(2000);
  digitalWrite(8, LOW);  
  cell.begin(4800);
  delay(30000);
  cell.println("AT+CMGF=1");
  delay(200);
  cell.println("AT+CNMI=3,3,0,0");
  delay(200);
}

void loop()
{
  if (cell.available() > 0)
  {
    inchar = cell.read();
    if (inchar == '#')
    {
      delay(10);
      inchar = cell.read();
      if (inchar == '0')
      {
        mainsOff();
      }
      else if (inchar == '1')
      {
        mainsOn();
      }
      delay(10);
      cell.println("AT+CMGD=1,4"); // delete all SMS
    }
  }
}
