// Project #25 - Creating a TPIC6B595 Binary Number Display

#define latch 8 // latch RCK pin
#define clock 9 // clock SRCK pin
#define data 10 // data SERIN pin

void displayBinary(int displayNumber)
{
  digitalWrite(latch, LOW);
  shiftOut(data, clock, MSBFIRST, displayNumber);
  digitalWrite(latch, HIGH);
}

void setup()
{
  Serial.begin(9600);
  pinMode(latch, OUTPUT);
  pinMode(clock, OUTPUT);
  pinMode(data, OUTPUT);
}

void loop()
{
  long number = 0;
  long entry = 0;
  Serial.flush();
  while (Serial.available() == 0) {}
  while (Serial.available() > 0)
  {
    number = number * 10;
    entry = Serial.read() - '0';
    number = number + entry;
    delay(5);
  }
  displayBinary(number);
  Serial.print("You entered: ");
  Serial.print(number);
  Serial.print(", which is ");
  Serial.print(number, BIN);
  Serial.println(" in binary.");  
}
