// Project #27b - Creating a Giant Four-Digit Seven-Segment LED Display

#define latch 8  // Latch RCK pin
#define clock 9  // Clock SRCK pin
#define data 10  // Data SERIN pin

int digits[] = { B00111111,    // 0
                 B00000110,    // 1
                 B01011011,    // 2
                 B01001111,    // 3
                 B01100110,    // 4
                 B01101101,    // 5
                 B01111101,    // 6
                 B00000111,    // 7
                 B01111111,    // 8
                 B01100111 };  // 9

void sendNumbers(int numbers[], int dp) {
  digitalWrite(latch, LOW);
  for (int i = 0; i < 4; i++) {
    int dig_idx = numbers[i];
    if (dp == i) {
      // Display the digit
      shiftOut(data, clock, MSBFIRST, digits[dig_idx] | B10000000);
      Serial.print(".");
    } else {
      shiftOut(data, clock, MSBFIRST, digits[dig_idx]);
    }
  }
  digitalWrite(latch, HIGH);
  Serial.println("");
}

void setup() {
  Serial.begin(9600);
  randomSeed(analogRead(0));
  pinMode(latch, OUTPUT);
  pinMode(clock, OUTPUT);
  pinMode(data, OUTPUT);
}

void loop() {
  int numbers[4] = { random(0, 10), random(0, 10), random(0, 10), random(0, 10) };
  sendNumbers(numbers, random(0, 3));
  delay(1000);
}