// Project 28 - Building a Simple MP3 Player

#define HEADER_START   0x7E
#define HEADER_VERSION 0xFF
#define TAIL_END       0xEF
#define CMD_PLAY_NEXT  0x01
#define CMD_PLAY_PREV  0x02
#define CMD_PLAY_IDX   0x03


int8_t commands[8] = {0, 0, 0, 0, 0, 0, 0, 0};
// Holds command set to send to MP3
#include <SoftwareSerial.h>
SoftwareSerial MP3(2, 3); // module TX to D2; module RX to D3
#include <analogkeypad.h>
analogkeypad keypad;

void controlMP3(int8_t command, int16_t data)
{
    commands[0] = HEADER_START;
    commands[1] = HEADER_VERSION;
    commands[2] = 0x06;
    commands[3] = command;
    commands[4] = 0x00;   
    commands[5] = (int8_t)(data >> 8);
    commands[6] = (int8_t)(data);
    commands[7] = TAIL_END;   //
    for (int i = 0; i < 8; i++)
    {
        MP3.write(commands[i]);
    }
    delay(100);
}

void setup() 
{
    MP3.begin(9600);
    controlMP3(0x09, 0x02); // Select uSD card for operation.
    delay(500);
}

void loop()
{
    switch (keypad.readKeypad()) // Read button status.
    {
        case 7 : controlMP3(0x0D, 0); break; // Play
        case 8 : controlMP3(0x0E, 0); break; // Pause
        case 9 : controlMP3(0x02, 0); break; // Previous track
        case 10 : controlMP3(0x01, 0); break; // Next track
        case 11 : controlMP3(0x05, 0); break; // Volume down
        case 12 : controlMP3(0x04, 0); break; // Volume up
    }
    delay(250);
}