// Project #29 – Building an MP3 Player Sound Board

#define HEADER_START   0x7E
#define HEADER_VERSION 0xFF
#define TAIL_END       0xEF
#define CMD_PLAY_NEXT  0x01
#define CMD_PLAY_PREV  0x02
#define CMD_PLAY_IDX   0x03


int8_t commands[8] = {0, 0, 0, 0, 0, 0, 0, 0}; 
// Holds command set to send to MP3
#include <SoftwareSerial.h>
SoftwareSerial MP3(2, 3); // Module TX to D2; module RX to D3
#include <analogkeypad.h>
analogkeypad keypad;

void controlMP3(int8_t command, int16_t data)
{
    commands[0] = 0x7E;
    commands[1] = 0xFF;
    commands[2] = 0x06;
    commands[3] = command;
    commands[4] = 0x00;   
    commands[5] = 0x01;
    commands[6] = (int8_t)(data);
    commands[7] = 0xEF;   //
    for (int i = 0; i < 8; i++)
    {
        MP3.write(commands[i]);
    }
    delay(100);
}

void setup() 
{
    MP3.begin(9600);
    controlMP3(0x09, 0x02); // Select uSD card for operation.
    delay(500);
}

void loop()
{
    switch (keypad.readKeypad()) // Read button status
    {
        case 1 : controlMP3(0x0F, 1); break; // Play 01/001001.mp3
        case 2 : controlMP3(0x0F, 2); break; // Play 01/002002.mp3
        case 3 : controlMP3(0x0F, 3); break; // Play 01/003003.mp3
        case 4 : controlMP3(0x0F, 4); break; // And so on... 
        case 5 : controlMP3(0x0F, 5); break;  
        case 6 : controlMP3(0x0F, 6); break; 
        case 7 : controlMP3(0x0F, 7); break;
        case 8 : controlMP3(0x0F, 8); break; 
        case 9 : controlMP3(0x0F, 9); break;
        case 10 : controlMP3(0x0F, 10); break; 
        case 11 : controlMP3(0x0F, 11); break;
        case 12 : controlMP3(0x0F, 12); break;
    }
    delay(250);
}