// Project #32: Logging Data with USB Keyboard Emulation
#define Ctrl 128
#define Semicolon 59
#define Shift 129
#define Tab 179
#define Enter 176

#include "Keyboard.h"
#include "Wire.h"
#include "Adafruit_BMP085.h"
  Adafruit_BMP085 bmp;

void spreadsheetDate()
{
    Keyboard.press(Ctrl); 
    Keyboard.press(Semicolon);
    delay(100);
    Keyboard.releaseAll(); // Let go of all buttons. 
}

void spreadsheetTime()
{
    Keyboard.press(Ctrl);
    Keyboard.press(Shift); 
    Keyboard.press(Semicolon); 
    delay(100);
    Keyboard.releaseAll(); // Let go of all buttons. 
}

void pressTab()
{
    Keyboard.write(Tab); 
}

void pressEnter()
{
    Keyboard.write(Enter); 
}

void setup() 
{
    Keyboard.begin();
    bmp.begin();
    delay(10000);
}

void loop() 
{
    spreadsheetDate();
    pressTab();
    spreadsheetTime();
    pressTab();
    Keyboard.print(bmp.readTemperature());
    pressTab();
    Keyboard.print(bmp.readPressure());
    pressEnter();
    delay(5000);
}
