// Project 36 - Logging Sensor Data to USB Flash Drive

#include "Wire.h"
#include <Adafruit_BMP085.h>
#include <Ch376msc.h>
#include <SoftwareSerial.h>

Adafruit_BMP085 bmp;
SoftwareSerial USBserial(7, 6);
Ch376msc USBdrive(USBserial);

char floatChar[8] = "";

void fileAppend()
{
  Serial.println("fileAppend()");
  USBdrive.setFileName("TEMPDATA.TXT");  // set the file name
  if (USBdrive.openFile() == ANSW_USB_INT_SUCCESS) 
  {            
    USBdrive.moveCursor(CURSOREND);
  }
  if (USBdrive.getFreeSectors()) 
  {
    dtostrf(bmp.readTemperature(),2,2,floatChar); 
    USBdrive.writeFile(floatChar, strlen(floatChar));
    USBdrive.writeChar(',');
    USBdrive.writeChar('C');
    USBdrive.writeChar(',');

    USBdrive.writeNum(bmp.readPressure());
    USBdrive.writeChar(',');
    USBdrive.writeChar('P');
    USBdrive.writeChar('a');
    USBdrive.writeChar(',');

    dtostrf(bmp.readAltitude(),5,1,floatChar); 
    USBdrive.writeFile(floatChar, strlen(floatChar));
    USBdrive.writeChar(',');
    USBdrive.writeChar('m');
    USBdrive.writeChar('\n'); 
  } else  {
    Serial.println("Disk full");
  }
  USBdrive.closeFile();
  Serial.println("Finished");
}

void setup() 
{
  bmp.begin();
  Serial.begin(115200);   // for serial monitor
  USBserial.begin(9600);    // for USB module
  USBdrive.init();
  delay(5000);
}

void loop() 
{
  if (USBdrive.checkIntMessage())
  {
    if (USBdrive.getDeviceStatus()) {
      Serial.println(F("Flash drive attached!"));
    } else {
      Serial.println(F("Flash drive detached!"));
      return;
    }
  }

  fileAppend();
  delay(5000); // arbitrary delay
}