// Project #38 – Configuring a Project via USB Flash Drive

#include <EEPROM.h>
#include <Ch376msc.h>
#include <SoftwareSerial.h>
SoftwareSerial Serial1(9, 8);
Ch376msc USBdrive(Serial1);

void loadData()
{
  int _data;
  int pointer = 0;

  USBdrive.setFileName("SETTINGS.TXT");
  USBdrive.openFile();
  Serial.println(F("Reading data from USB:"));

  while(!USBdrive.getEOF())
  {
    _data = USBdrive.readLong();
    EEPROM.write(_data,pointer);
    Serial.print(pointer); Serial.print(" "); Serial.println(_data);
    pointer++;
  }
  USBdrive.closeFile();
  Serial.println(F("Finished."));
  Serial.println();
}

void useData()
{
  int a;
  int _data;
  Serial.println("Reading from EEPROM...");
  for (a=0; a<100; a++)
  {
    _data = EEPROM.read(a);
    PORTD = _data;
    Serial.print(a); Serial.print(" "); Serial.println(_data);
    delay(100);
  }
}

void setup()
{
  DDRD = B11111111; 
  Serial.begin(115200);
  Serial1.begin(9600);
  USBdrive.init();
  delay(5000);
}

void loop() 
{
  if (USBdrive.checkIntMessage())
  {
    if (USBdrive.getDeviceStatus()) {
      Serial.println(F("Flash drive attached!"));
    } else {
      Serial.println(F("Flash drive detached!"));
      return;
    }
  }

  loadData();
  delay(1000);

  useData();
  delay(1000);

  do {} while (1); // halt  

}