// Project #39 – Creating an RGB LED Tester

#include <Wire.h>
#include <LiquidCrystal_PCF8574.h>
LiquidCrystal_PCF8574 lcd(0x27);
#include <PS2Keyboard.h>
PS2Keyboard keyboard;

#define red 11
#define green 10
#define blue 9

int readDigit()
{
  int _digit=-1;
  do
  {
  if (keyboard.available()) 
  {
    // read the next key
    char c = keyboard.read();
     switch (c)
     {
       case '1' : _digit=_digit+2; break;
       case '2' : _digit=_digit+3; break;
       case '3' : _digit=_digit+4; break;
       case '4' : _digit=_digit+5; break;
       case '5' : _digit=_digit+6; break;
       case '6' : _digit=_digit+7; break;
       case '7' : _digit=_digit+8; break;
       case '8' : _digit=_digit+9; break;
       case '9' : _digit=_digit+10; break;                                                
       case '0' : _digit = 0; break;      
     }    
     lcd.print(c);
  }
  } while(_digit==-1);
  return _digit;
}

int get3digit()
{
  int z;
  z = readDigit()*100;
  z = z + (readDigit()*10);
  z = z + readDigit();  
  return z;
}

void setup() 
{
  Wire.begin();
  Wire.beginTransmission(0x27);
  lcd.begin(16, 2);
  lcd.setBacklight(255);
  keyboard.begin(4, 3);
  Serial.begin(9600);
  DDRB = B111111; // set LED pins to output
}

void loop()
{
  int _red;
  int _green;
  int _blue;
  int _delay;

  lcd.home();
  lcd.clear();
  lcd.setCursor(1, 0);
  lcd.print("R:");
  lcd.setCursor(4, 0);
  _red = get3digit();

  lcd.setCursor(8, 0);
  lcd.print("G:");
  lcd.setCursor(11, 0);
  _green = get3digit();

  lcd.setCursor(1, 1);
  lcd.print("B:");
  lcd.setCursor(4, 1);
  _blue = get3digit();

  lcd.setCursor(8, 1);
  lcd.print("T:");
  lcd.setCursor(11, 1);
  _delay = get3digit();

  analogWrite(red, _red);
  analogWrite(green, _green);  
  analogWrite(blue, _blue);  
  delay(_delay*1000);

  analogWrite(red, 0);
  analogWrite(green, 0);  
  analogWrite(blue, 0);  
}
