// Project #40 – Building a Text Capture Device

char _text[100];
int _counter = 0;
int xPosition = 0;
int yPosition = 1;
#include <SD.h>
#include <LiquidCrystal_PCF8574.h>
#include <Wire.h>
LiquidCrystal_PCF8574 lcd(0x27);
#include <PS2Keyboard.h>
PS2Keyboard keyboard;

void halt()
{
  do {} while (1);
}

void saveText(boolean _halt)
{
  if (!SD.begin(10))
  {
    lcd.setCursor(1, 1);
    lcd.print("SD card fail");
    halt();
  }
  File dataFile = SD.open("WRITING.TXT", FILE_WRITE);
  if (dataFile)
  {
    // save and clear array
    for (int i = 0; i < 100; i++)
    {
      dataFile.print(_text[i]);
      _text[i] = "";
    }
    dataFile.close();
  }
  if (_halt == true)
  {
    File dataFile = SD.open("WRITING.TXT", FILE_WRITE);
    if (dataFile)
    {
      dataFile.println();
      dataFile.println("----------------------------------------------------------------------------");
      dataFile.close();
    }
    lcd.setCursor(1, 1);
    lcd.print("OK remove card");
    halt();
  }
}

void setup()
{
  Wire.begin();
  Wire.beginTransmission(0x27);
  lcd.begin(16, 2);
  lcd.setBacklight(255);
  lcd.blink();
  lcd.clear();
  lcd.home();
  lcd.print("Start typing:");
  lcd.setCursor(xPosition, yPosition);
  keyboard.begin(4, 3);
  pinMode(10, OUTPUT);
}

void loop()
{
  if (keyboard.available())
  {
    char c = keyboard.read();
    if (c == PS2_ENTER)
    {
      _text[_counter] = '\n';
      _counter = _counter + 1;
      xPosition = 0;
      if (yPosition == 0) {
        yPosition = 1;
      } else if (yPosition == 1) {
        yPosition = 0;
      }
      lcd.setCursor(xPosition, yPosition);
    } else if (c == PS2_ESC)
    {
      lcd.home();
      lcd.clear();
      saveText(true);
    } else {
      _text[_counter] = c;
      lcd.print(_text[_counter]);
      _counter = _counter + 1;
      if (_counter >= 99)
      {
        saveText(false);
        _counter = 0;
      }
      xPosition++;
      if (xPosition > 15) {
        xPosition = 0;
        if (yPosition == 0) {
          yPosition = 1;
        } else if (yPosition == 1) {
          yPosition = 0;
        }
        lcd.setCursor(xPosition, yPosition);
      }
    }
  }
}
