// Project 41 - Capturing Data via Bluetooth

#define PIN_BT_TX 3
#define PIN_BT_RX 2
#include "Wire.h"
#include "Adafruit_BMP085.h"
#include <SoftwareSerial.h>
SoftwareSerial BT(PIN_BT_RX, PIN_BT_TX);
Adafruit_BMP085 bmp;

int temperature;
int pressure;

void setup() 
{
  // set the data rate for the SoftwareSerial port
  BT.begin(9600);
  // Send test message to other device
  BT.println("Hello from Arduino");
  bmp.begin();
}

void loop() 
{
  BT.print("Temperature = ");
  temperature = bmp.readTemperature();
  BT.print(temperature);
  BT.print(" degrees C");
  BT.print(" Pressure = ");
  BT.print(int(bmp.readPressure() / 100));
  BT.println(" hPa");
  delay(1000);
}
