// Project 42 - Using Bluetooth for Digital I/O Control

#define PIN_BT_TX 3
#define PIN_BT_RX 2
#include <SoftwareSerial.h>
SoftwareSerial BT(PIN_BT_RX, PIN_BT_TX);

void sendHelp()
{
  BT.println("Send 0~3 to turn on D8~11");
  BT.println("Send 4~7 to turn off D8~11");
}

void setup()
{
  // set digital pin to control as an output
  DDRB = B111111;
  // set the data rate for the SoftwareSerial port
  BT.begin(9600);
  // Send test message to other device
  BT.println("Hello from Arduino");
}

char a; // stores incoming character from other device

void loop()
{
  if (BT.available())
  {
    a = (BT.read());
    if (a == '0') { digitalWrite(8, HIGH); BT.println("D8 on"); }
    if (a == '1') { digitalWrite(9, HIGH); BT.println("D9 on"); }
    if (a == '2') { digitalWrite(10, HIGH); BT.println("D10 on"); }
    if (a == '3') { digitalWrite(11, HIGH); BT.println("D11 on"); }
    if (a == '4') { digitalWrite(8, LOW); BT.println("D8 off"); }    
    if (a == '5') { digitalWrite(9, LOW); BT.println("D9 off"); }    
    if (a == '6') { digitalWrite(10, LOW); BT.println("D10 off"); }    
    if (a == '7') { digitalWrite(11, LOW); BT.println("D11 off"); }    
    if (a == '?') { sendHelp(); }
  }
}
