// Project #47 - Monitoring Engine Data

#include <Canbus.h>
int requestDelay = 100;
char buffer[456];

void setup()
{
  Serial.begin(115200);
  // Test car Mitsubishi ASX uses 500 bps
  if (Canbus.init(CANSPEED_500)) // Initialize MCP2515 CAN controller at the specified speed
  {
    Serial.println("CAN initialization ok");
  } else
  {
    Serial.println("CAN initialization error");
  }
  delay(2000); 
}

void loop()
{
  Canbus.ecu_req(VEHICLE_SPEED, buffer);
  Serial.print("Speed: ");
  Serial.print(buffer);
  delay(requestDelay);

  Canbus.ecu_req(ENGINE_RPM, buffer);
  Serial.print(", RPM: ");
  Serial.print(buffer);
  delay(requestDelay);

  Canbus.ecu_req(THROTTLE, buffer);
  Serial.print(", Throttle: ");
  Serial.print(buffer);
  delay(requestDelay);

  Canbus.ecu_req(ENGINE_COOLANT_TEMP, buffer);
  Serial.print(", Coolant temp: ");
  Serial.print(buffer);
  delay(requestDelay);

  Canbus.ecu_req(O2_VOLTAGE, buffer);
  Serial.print(",  o2 Voltage: ");
  Serial.print(buffer);
  delay(requestDelay);

  Canbus.ecu_req(MAF_SENSOR, buffer);
  Serial.print(" , MAF sensor: ");
  Serial.println(buffer);
  delay(requestDelay);
}