// Project #48 - Logging OBDII Car Data

#include <Canbus.h>
int requestDelay = 100;
char buffer[456];

#include <SPI.h>
#include <SD.h>
int chipselect = 9;

void setup()
{
  Serial.begin(115200); 
  // Check uSD card
  if (!SD.begin(chipselect)) {
    Serial.println("Card failed, or not present");
    // Stop
    while (1);
  }
  Serial.println("Micro SD card initialized.");
    if (Canbus.init(CANSPEED_500))
  {
    Serial.println("CAN initialization ok");
  } else
  {
    Serial.println("CAN initialization error");
  }
  delay(2000);
}

void loop()
{
  // Open file on memory card 
  File dataFile = SD.open("CANBUS.TXT", FILE_WRITE);
  if (dataFile)
  {
    Canbus.ecu_req(VEHICLE_SPEED, buffer); 
    dataFile.print(buffer);
    delay(requestDelay);

    Canbus.ecu_req(ENGINE_RPM, buffer);
    dataFile.print(",");
    dataFile.print(buffer);
    delay(requestDelay);

    Canbus.ecu_req(THROTTLE, buffer);
    dataFile.print(",");
    dataFile.print(buffer);
    delay(requestDelay);

    Canbus.ecu_req(ENGINE_COOLANT_TEMP, buffer);
    dataFile.print(",");
    dataFile.print(buffer);
    delay(requestDelay);

    Canbus.ecu_req(O2_VOLTAGE, buffer);
    dataFile.print(",");
    dataFile.print(buffer);
    delay(requestDelay);

    Canbus.ecu_req(MAF_SENSOR, buffer);
    dataFile.print(",");
    dataFile.println(buffer);

    // Close file on memory card
    dataFile.close();
    delay(1000); // Around 1 second delay between logging data
  }
}
