// Project 52 - Creating an Arduino-to-Arduino Data Link over RS485
// Receiver

#include <Wire.h>
#include <LiquidCrystal_PCF8574.h>
LiquidCrystal_PCF8574 lcd(0x27);

#include <SoftwareSerial.h>
SoftwareSerial RS485(4, 3);

#define TXRX 2 // Using D2 for RS485 DE/RE

float temperature = 0;

void setup() {
  Wire.begin();
  Wire.beginTransmission(0x27);
  lcd.begin(16, 2);
  lcd.setBacklight(255);
  lcd.clear();
  RS485.begin(9600);
  pinMode(TXRX, OUTPUT);
  digitalWrite(TXRX, LOW);  // RS485 receive
}

void loop()
{
  byte incoming = RS485.available();
  if (incoming != 0)
  {
    temperature = RS485.parseFloat();
    lcd.home();
    lcd.clear();    
    lcd.setCursor(0, 0);
    lcd.print("Temperature:");
    lcd.setCursor(0, 1);    
    lcd.print(temperature);
    lcd.print(" Celsius");    
  }
}