// Project 60 - Using Telegram for Automated Data Transmission

#include <WiFi.h>
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>
#include <ArduinoJson.h>
#include <Adafruit_BMP085.h>

Adafruit_BMP085 bmp;

// Enter your Wi-Fi network SSID and password
const char* ssid = "SSID";
const char* password = "password";

// Enter your Telegram bot token and chatID
#define botToken "5629865778:AAEEkM9pjB2a9Xoky4y6IJxsmVJRp12siYc"
#define chatID "878761727"

WiFiClientSecure client;
UniversalTelegramBot bot(botToken, client);

void setup() {
  bmp.begin();
  Serial.begin(115200);

  // Connect to Wi-Fi
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);

  client.setCACert(TELEGRAM_CERTIFICATE_ROOT);  // Add root certificate for api.telegram.org
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to Wi-Fi...");
  }
  // Print ESP32 Local IP Address
  Serial.println(WiFi.localIP());
}

void loop() {
  String messageOut;  // Used for assembling messages to send
  messageOut = "Temperature (C): ";
  messageOut += String(bmp.readTemperature());
  bot.sendMessage(chatID, messageOut, "");
  delay(5000);
}